'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = muiThemeable;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _stylesRawThemesLightRawTheme = require('./styles/raw-themes/light-raw-theme');

var _stylesRawThemesLightRawTheme2 = _interopRequireDefault(_stylesRawThemesLightRawTheme);

var _stylesThemeManager = require('./styles/theme-manager');

var _stylesThemeManager2 = _interopRequireDefault(_stylesThemeManager);

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function muiThemeable(WrappedComponent) {
  var MuiComponent = function MuiComponent(props, _ref) {
    var _ref$muiTheme = _ref.muiTheme;
    var muiTheme = _ref$muiTheme === undefined ? _stylesThemeManager2['default'].getMuiTheme(_stylesRawThemesLightRawTheme2['default']) : _ref$muiTheme;

    return _react2['default'].createElement(WrappedComponent, _extends({}, props, { muiTheme: muiTheme }));
  };

  MuiComponent.displayName = getDisplayName(WrappedComponent);
  MuiComponent.contextTypes = {
    muiTheme: _react2['default'].PropTypes.object
  };
  MuiComponent.childContextTypes = {
    muiTheme: _react2['default'].PropTypes.object
  };

  return MuiComponent;
}

module.exports = exports['default'];